import * as hono from 'hono';
import { Session, Store, CookieStore } from 'hono-sessions';
import { CookieOptions } from 'hono/utils/cookie';

interface SessionOptions {
    store?: Store | CookieStore;
    expireAfterSeconds?: number;
    cookieOptions?: CookieOptions;
    sessionCookieName?: string;
}
interface CookieStoreOptions {
    encryptionKey: string;
    cookieOptions?: CookieOptions;
    sessionCookieName?: string;
}
type Options = SessionOptions & CookieStoreOptions;
declare function session(opts: Options): hono.MiddlewareHandler;
interface SessionVariables {
    session: Session;
    session_key_rotation: boolean;
}
declare module "hono" {
    interface ContextVariableMap extends SessionVariables {
    }
}

export { type SessionVariables, session };
